/*----------------------------------------------------------------------------
 * import
 *----------------------------------------------------------------------------*/
import swarm.*;
import swarm.objectbase.*;
import swarm.defobj.*;
import swarm.space.*;
import swarm.gui.*;

/*----------------------------------------------------------------------------
 * class   : SegregatedAgent
 * comment : Bug.java̓]p (AgentƂׂ낤)
 *----------------------------------------------------------------------------*/
public class SegregatedAgent extends SwarmObjectImpl {
  int xPos, yPos;
  int worldXSize, worldYSize;
  Grid2d world;

  /* ǉ */
  SegregatedChurchSpace churchSpace;  // ԃIuWFNg
  int race;                 // l
  int color;                // \F (, `, ݒňقȂ)
  int searchSpace;          // slɊ֘A
  int raceNum;              // 퐔
  double unhappiness;       // sl
  boolean philanthropism;   // `tO
  boolean inChurch;         // /OtO
  
  /**
   * RXgN^ */
  public SegregatedAgent(Zone aZone, int raceNum, double seedPhilan){
    super(aZone);

    // _Ɍ
    color = race = Globals.env.uniformIntRand.getIntegerWithMin$withMax(1,raceNum);

    // `/񔎈`_Ɍ
    if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < seedPhilan) {
      // Fς (邭)
      color += 3;
      philanthropism = true;
    } else {
      philanthropism = false;
    }

    searchSpace = 1;
    unhappiness = 0;
    inChurch=false;
  }
  
  /**
   * ԂƋ, Xɂ̍L擾 */
  public Object setWorld$Space(Grid2d w,SegregatedChurchSpace c){
    world=w;
    churchSpace=c;
    worldXSize = world.getSizeX();//Ƃ肠ɏĂB
    worldYSize = world.getSizeY();
    return this;
  }
  
  /**
   * ʒuݒ */
  public Object setX$Y(int x, int y){
    xPos = x;
    yPos = y;
    return this;
  }

  /**
   * 1Xebv̏ */
  public void step(){
    int newX, newY;     // Vʒu
    int churchValue=0;  // l (/Ȃ, Ȃǂ̖̋)
    double newUnhappiness = 0; // sl (Ȃ疞)
    SegregatedAgent aSegregatedAgent;
    
    // ړ}X_Ɍ
    do {
      newX = xPos + Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1,1);
      newY = yPos + Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1,1);
    } while( ( (xPos == newX) && (yPos == newY) ) && inChurch);
    
    // Ԃzꍇ͔ΑɈړ
    newX = (newX + worldXSize) % worldXSize;
    newY = (newY + worldYSize) % worldYSize;
    
    // ړ}X̎8}XT
    for (int i = ( newX - searchSpace ); i<= ( newX + searchSpace ); i++) {
      int sx = (i + worldXSize) % worldXSize;
      for (int j = ( newY - searchSpace ); j<= ( newY + searchSpace ); j++) {
        int sy = (j + worldYSize) % worldYSize;

        // slvZ (l)
        if( ( i != xPos ) || ( j != yPos ) ) { // }XȊO (܂߂Ȃ)

          // l
          if( ( aSegregatedAgent = (SegregatedAgent)world.getObjectAtX$Y( sx, sy ) ) != null) {

            float fValue = 1;

            // vpeBɏ
            if ( philanthropism == true ) {           // `
              newUnhappiness -= fValue;
            } else if ( aSegregatedAgent.getRace() != race ) { // ٖ
              newUnhappiness += fValue;
            } else if ( aSegregatedAgent.getRace() == race ) { // 
              newUnhappiness -= fValue;
            }
          }
        }

        // slvZ ()
        if( ( i != newX ) || ( j != newY ) ) { // ړȊO

          if ( (churchValue = churchSpace.getValueAtX$Y( sx, sy )) != 0) {
            float fValue = 1;
            churchValue %= 3;
            newUnhappiness += (float)((churchValue == (race % 3)) ? -1: 1);
          }
        } else { // ړ

          // 
          if ( (churchValue = churchSpace.getValueAtX$Y(newX, newY)) != 0) {
            churchValue %= 3;
            newUnhappiness += (churchValue == (race % 3)) ? -3: +3;
          }
        }
      }
    }

    // NȂΈړ
    if (world.getObjectAtX$Y(newX, newY) == null){

      // slȂꍇ, ܂͋ɂꍇ
      if( (newUnhappiness <= unhappiness)  || inChurch ) {
        world.putObject$atX$Y(null,xPos,yPos);
        xPos = newX;
        yPos = newY;
        unhappiness = newUnhappiness;
        world.putObject$atX$Y(this,newX,newY);
      }
    }

    // ɂꍇƂȂꍇŐFω
    if ( churchSpace.getValueAtX$Y(xPos, yPos) != 0) {
      inChurch=true;
      color=13;  // white
    } else {
      inChurch=false;
      color=race + (philanthropism ? 3: 0); // KF
    }
  }

  /**
   * 擾 */
  public int getRace() {
    return race;
  }
  
  /**
   * sl擾 */
  public double getUnhappiness() {
    return unhappiness;
  }
  
  public Object drawSelfOn(Raster r){
    r.drawPointX$Y$Color(xPos,yPos,(byte)color);//LXgKv
    return this;
  }
}

/*----------------------------------------------------------------------------
 * end of file
 *----------------------------------------------------------------------------*/
